library(tidyverse)
load("D:/User/Dropbox (Personal)/Education/Classes/18Fall_EPID799C_RforEpi/lectures/2018.10.29-31 L17-18 Map Env.rdata")

adist("orange", "oraaanage")

#______________________________________
# Kmeans clustering ####
#______________________________________
library(factoextra)
# https://www.statmethods.net/advstats/cluster.html

head(county_results)
county_results = county_results %>% filter(county_name != "Out of State")
county_results$n_scaled = county_results$n / sum(county_results$n, na.rm=T) * 100
county_profile = county_results[, c("n_scaled", "pct_preterm", "pct_pnc5")] 
head(county_profile)
# could: mutate_all(as.vector(scale)) to standardize. Other ways to do this!

# Two variables at once.
county_results$exp_out_cluster = county_profile %>% 
  select(contains("pct")) %>% 
  kmeans(4, iter.max = 30) %>% `[[`("cluster")

ggplot(county_results, 
       aes(pct_pnc5, pct_preterm, 
           color=as.factor(exp_out_cluster), 
           group = as.factor(exp_out_cluster)))+
  geom_point()+geom_density2d()

# More than two - Determine number of clusters
wss <- (nrow(county_profile)-1)*sum(apply(county_profile,2,var))
fviz_nbclust(county_profile, kmeans, method="wss", nboot=50)
fviz_nbclust(county_profile, kmeans, method="gap_stat", nboot=50)

# Let's try 4 - WSS starts to flatten out.

county_kmeans = kmeans(county_profile, centers = 4)
county_profile$cluster = county_kmeans$cluster # add back to data
county_profile$cluster = as.factor(county_kmeans$cluster) # add back to data
head(county_profile)

fviz_cluster(county_kmeans, data=county_profile[,1:3])+
  geom_text(aes(label = county_results$county_name, color=cluster))

county_profile %>% 
  mutate(county_name = county_results$county_name) %>% # add back
  gather(feature, value, -cluster, -county_name) %>% #head() %>%
  ggplot(aes(feature, value, color=cluster, label=county_name)) +
  facet_grid(feature~cluster, scales="free_y")+
  geom_point()+
  geom_text()+
  geom_density_2d()

county_profile %>% 
  mutate_at(vars(contains("_")), function(x){as.vector(scale(x))}) %>%
  group_by(cluster) %>%
  summarise_all(mean) %>%
  gather(feature, value, -cluster) %>%
  ggplot(aes(feature, value, color=cluster, label=cluster, group=cluster)) +
  #facet_grid(feature~cluster, scales="free_y")+
  geom_line()

autoplot(county_kmeans, data=county_profile)
str(county_profile)

# Consider also adding in county-specific EMM!

#______________________________________
#  Heierachical clustering
#______________________________________
# Linkage criteria for heierachical clustering - iterative max distance between neighbors. 
# Nearest neighbors
# complete linkage - max distance between two sets
# min distance
# avg distance
h_clust_data = county_profile[,1:3]; row.names(h_clust_data) = county_results$county_name
h_clusters = hclust(dist(h_clust_data))
plot(h_clusters)
county_profile$h_clusters_cut = cutree(h_clusters, k=4) # # groups; h= for height cut
ggplot(county_profile, aes(pct_pnc5, pct_preterm, 
                           color=as.factor(h_clusters_cut), group=as.factor(h_clusters_cut)))+
  geom_point() + geom_density2d()
head(county_profile)
# https://www.r-bloggers.com/hierarchical-clustering-in-r-2/
#______________________________________
# PCA
#______________________________________
# Thanks, https://tgmstat.wordpress.com/2013/11/28/computing-and-visualizing-pca-in-r/
county_pca = prcomp(county_profile[,1:3], center=T, scale. =T)
plot(county_pca, type="l")
summary(county_pca)
class(county_pca)
predict(county_pca)

library(ggfortify)
autoplot(county_pca, data=county_profile, label=T, loadings = T)
# NOTE PCA is more appropriate with more features where dimensional reduction helps
# nice https://cran.r-project.org/web/packages/ggfortify/vignettes/plot_pca.html

#.............
#LCA
#.............
#https://maksimrudnev.com/2016/12/28/latent-class-analysis-in-r/
